<template>
  <v-row class="flex-column app-comparison" no-gutters>
    <h2 class="display-1 text-center font-weight-medium pt-5 pb-5 mb-4">
      Compare
    </h2>
    <v-simple-table v-if="properties.length" dense>
      <template v-slot:default>
        <thead>
          <tr>
            <!-- Cover and name -->
            <th style="border-bottom: 0; width: 120px" />
            <th
              v-for="property in properties"
              :key="property.id"
              class="pb-3 text-center"
              :style="{width: (100 / properties.length) + '%', borderBottom: 0, position: 'relative', overflow: 'visible'}"
            >
              <v-btn
                absolute
                fab
                top
                x-small
                right
                color="accent"
                @click.capture.stop="comparison.toggle(property)"
              >
                <v-icon>{{ mdiClose }}</v-icon>
              </v-btn>
              <v-img :src="property.cover" :aspect-ratio="4/3" max-height="15vh" />
              <nuxt-link class="black--text" :to="{ name: 'apartment-id', params: { id: property.id } }">
                {{ property.name }}
              </nuxt-link>
            </th>
          </tr>
        </thead>
        <tbody>
          <!-- Beds -->
          <tr v-for="n in (maxBeds - minBeds)" :key="n" dense>
            <td class="text-right py-2" style="border-bottom: 0">
              <span v-if="n === 0" class="font-weight-medium">
                Studio
              </span>
              <span v-else class="font-weight-medium">
                {{ n }} Bed{{ n > 1 ? 's':'' }}
              </span>
            </td>
            <td v-for="property in properties" :key="property.id + '' + n" class="text-center">
              <span v-if="!property.summary.floorPlans[n]">-</span>
              <span v-else>
                ${{ property.summary.floorPlans[n].priceRanges.join(' - $') }}
              </span>
            </td>
          </tr>
          <!-- Sqrt -->
          <tr>
            <td class="text-right pt-3 pb-1" style="border-bottom: 0">
              <span class="font-weight-medium">
                Sqrt feet
              </span>
            </td>
            <td v-for="property in properties" :key="property.id" class="text-center">
              <span>
                {{ getSqrt(property.summary).join(' - ') }}
              </span>
            </td>
          </tr>
          <!-- Built year -->
          <tr>
            <td class="text-right pb-3 pt-1" style="border-bottom: 0">
              <span class="font-weight-medium">
                Property Built
              </span>
            </td>
            <td v-for="property in properties" :key="property.id" class="text-center">
              <span>{{ getYear(property) }}</span>
            </td>
          </tr>
          <!-- Checks -->
          <tr v-for="check in CHECKS" :key="check.name" dense>
            <td class="text-right py-2" style="border-bottom: 0">
              <span class="font-weight-medium">
                {{ check.name }}
              </span>
            </td>
            <td v-for="property in properties" :key="property.id" class="text-center">
              <template v-if="property.amenities.some(check.test)">
                <v-icon color="accent">
                  {{ mdiCheck }}
                </v-icon>
              </template>
              <span v-else>-</span>
            </td>
          </tr>
        </tbody>
      </template>
    </v-simple-table>
    <p v-else class="body-1 py-4 text-center">
      Select and compare from your favorites.<br>
      Start by clicking the <v-icon>{{ mdiCompare }}</v-icon>
      button on any listing.
    </p>
  </v-row>
</template>

<script lang="ts">
import { mdiClose, mdiCheck, mdiCompare } from '@mdi/js'
import { defineComponent, computed, ref } from '@vue/composition-api'
import { IRentProperty, IAmenity } from 'apartments-shared'
import { formatFullAddress } from '@/utils'
import { useComparison } from '@/hooks/utils'

const CHECKS = [
  { name: 'Pets', test: (amenity: IAmenity) => amenity.category === 'pet-policy' },
  { name: 'Pool', test: (amenity: IAmenity) => amenity.name === 'pool' },
  { name: 'Gym', test: (amenity: IAmenity) => amenity.name === 'gym' },
  { name: 'Parking', test: (amenity: IAmenity) => amenity.category === 'parking' },
  { name: 'WiFi', test: (amenity: IAmenity) => amenity.name === 'wi-fi' }
]

export default defineComponent({
  setup (_, { root: { $store }, emit }) {
    const properties = computed<IRentProperty[]>(() => {
      return $store.getters['properties/getCompareList'] as IRentProperty[]
    })
    const values = computed<number[]>(() =>
      properties.value.flatMap(v => Object.keys(v.summary?.floorPlans ?? {})).map(Number))
    const minBeds = computed<number>(() => Math.min(...values.value))
    const maxBeds = computed<number>(() => Math.max(...values.value))
    const getYear = (property: IRentProperty) => {
      const am = property.amenities.find(b => b.title.includes('Built in'))
      if (!am) { return '-' }
      return am.title.replace(/[^\d]+/, '')
    }
    const removeSelection = (idx: number) => {
      $store.commit('properties/removeCompare', idx)
      if (!properties.value.length) { emit('close') }
    }
    const getSqrt = (summary: IRentProperty['summary']) => {
      if (!summary) { return }
      const floor = Object.values(summary.floorPlans)
      const mins = floor.map(f => f.sizeRanges[0])
      const maxs = floor.map(f => f.sizeRanges[1])
      return [Math.min(...mins), Math.max(...maxs)]
    }
    const comparison = useComparison()

    return {
      properties,
      mdiClose,
      getSqrt,
      comparison,
      removeSelection,
      getYear,
      mdiCompare,
      minBeds,
      maxBeds,
      CHECKS,
      mdiCheck,
      showSheet: ref(false),
      formatFullAddress
    }
  }
})
</script>

<style>
.app-comparison .v-data-table__wrapper {
  overflow: visible !important;
}
.app-comparison .v-btn::before {
  display: none;
}
</style>
